<template>
    <div class="login-content mt-3">
        <div class="row justify-content-center mt-3">
            <div class="col-md-6">
                <div class="card">
                    <div class="card-header">
                        <img 
                            width="50%"
                            src="@/assets/img/login-page.png" 
                            alt="" 
                            class="card-image">
                    </div>
                    <div class="card-body">
                        <div class="form-group">
                            <input  
                                v-model="user"
                                type="email" 
                                class="form-control">
                        </div>
                        <div class="form-group">
                            <input  
                                v-model="password"
                                @keydown.enter="submitFormLogin()"
                                type="password" 
                                class="form-control">
                        </div>
                        <div class="form-group text-right">
                            <button 
                                class="btn btn-outline-primary"
                                @click="submitFormLogin()"
                            >
                                Ingresar
                            </button>
                        </div>
                    </div>
                </div>
                <div class="alert alert-danger" v-if="message !== '' ">
                    {{ message }}
                </div>

            </div>
        </div>
    </div>
</template>
<style>
</style>
<script lang="ts">
    import Vue from 'vue'
    import Swal from 'sweetalert2'

    import { mapActions } from 'vuex'   
    export default Vue.extend({
        name: 'login-component',
        data() {
            return {
                user: '',
                password: '',
                isLoading: false,
                message: ''
            }
        },
        methods: {
            ...mapActions({
                signIn: 'signIn'
            }),
            submitFormLogin():void {
                if(this.user == '' || this.password == '' ) {
                    Swal.fire({ title: 'Información', text: 'Debe ingresar usuario y/o contraseña', icon: 'info'})
                }else {
                    this.isLoading = true
                    const form = {
                        email: this.user,
                        password: this.password
                    }
                    this.signIn(form)
                        .then( () => {
                            this.$router.push({
                                name: 'home'
                            })
                        })
                        .catch((e) => {
                            if(e.response.status == 422 ) {
                                this.message = ''
                                for (const key in e.response.data) {
                                    this.message += (e.response.data[key])
                                }
                            }
                            
                        }) 
                    .catch(() => {    
                        this.isLoading = false
                        Swal.fire({ title: 'Información', text: 'No se ha podido iniciar sesión', icon: 'warning'})
                    })
                }

            }   
        }
    })
</script>